library ieee;
use ieee.std_logic_1164.all;

entity mcm_cycle is
	port( A,B : in integer range 0 to 255;
	      nw,clk: in std_logic;
		  R: out integer range 0 to 255;
		  ready: out std_logic);
end mcm_cycle;

architecture beh of mcm_cycle is
begin
process (clk)
variable ma,mb: integer range 0 to 255;
begin
	if clk'event and clk='0' then
		if nw='1'  then
			ma:= A;
			mb:= B;	
			ready<= '0';
		elsif ma=mb then 
			R<= ma; 
			ready <= '1';
		elsif ma<mb then
			ma:= ma+A;
		else mb:=mb+B;
		end if;
	end if;
end process;
end beh;			
			
