library ieee;
use ieee.std_logic_1164.all;

entity mcm is
	port( A,B : in integer range 0 to 255;
	      nw,clk: in std_logic;
		  R: out integer range 0 to 255;
		  ready: out std_logic);
end mcm;

architecture beh of mcm is
begin
process (clk)
variable ma,mb: integer range 0 to 255;
begin
	if clk'event and clk='0' then
		if nw='1'  then
			ma:= A;
			mb:= B;
			while ma/= mb loop
				if ma < mb then
					ma:=ma+A;
				else mb:=mb+B;
			    end if;
			end loop;
			R<= ma;
			ready <= '1';
	    else ready <= '0';
		end if;
	end if;
	end process;
end beh;