library ieee;
use ieee.std_logic_1164.all;

entity mcm_tb_cycle is
end mcm_tb_cycle;

architecture tbbmcm of mcm_tb_cycle is
 component mcm_cycle is
	port( A,B : in integer range 0 to 255;
	      nw,clk: in std_logic;
		  R: out integer range 0 to 255;
		  ready: out std_logic);
end  component;

signal A,B,R: integer range 0 to 255;
signal nw,clk,ready: std_logic;

begin
	dut: mcm_cycle port map (A,B,nw,clk,R,ready);
	
	process
	begin
		clk <= '0';
		wait for 5 ns;
		clk <= '1';
		wait for 5 ns;
	end process;
	
	nw <= '0' after 0 ns, '1' after 11 ns, '0' after 21 ns, '1' after 101 ns, '0' after 111 ns;
	
	A<= 3 after 0 ns, 4 after 100 ns;
	B<= 2 after 0 ns, 5 after 100 ns;
	
end tbbmcm;